"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react2 = require("@emotion/react");

var _merge = _interopRequireDefault(require("lodash/merge"));

var _Context = _interopRequireDefault(require("./Context"));

var _defaultTheme = _interopRequireDefault(require("./defaultTheme"));

var _isServer = _interopRequireDefault(require("../util/isServer"));

var _mapColors = _interopRequireDefault(require("../util/mapColors"));

var _excluded = ["extra"];

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function getLocation() {
  var _window$location = window.location,
      origin = _window$location.origin,
      href = _window$location.href;
  return href.replace(origin, '');
}

function modifyTheme(nextTheme) {
  var mergedTheme = (0, _merge["default"])(_defaultTheme["default"], nextTheme);

  var _mergedTheme$colors = mergedTheme.colors,
      extra = _mergedTheme$colors.extra,
      named = _objectWithoutProperties(_mergedTheme$colors, _excluded);

  return Object.assign(mergedTheme, {
    Paper: _objectSpread(_objectSpread(_objectSpread({}, mergedTheme.Paper), (0, _mapColors["default"])(named, 'backgroundColor')), (0, _mapColors["default"])(extra, 'backgroundColor', 'color'))
  });
}

var UiProvider = /*#__PURE__*/function (_Component) {
  _inherits(UiProvider, _Component);

  var _super = _createSuper(UiProvider);

  function UiProvider() {
    var _this;

    _classCallCheck(this, UiProvider);

    for (var _len = arguments.length, _args = new Array(_len), _key = 0; _key < _len; _key++) {
      _args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(_args));

    _defineProperty(_assertThisInitialized(_this), "state", {
      touchDetected: false,
      theme: modifyTheme(_this.props.theme)
    });

    _defineProperty(_assertThisInitialized(_this), "trackTouch", function () {
      _this.setState({
        touchDetected: true
      });

      _this.untrackTouch();
    });

    _defineProperty(_assertThisInitialized(_this), "untrackTouch", function () {
      return window.removeEventListener('touchstart', _this.trackTouch);
    });

    _defineProperty(_assertThisInitialized(_this), "changeTheme", function () {
      var _this$props;

      var nextTheme = (_this$props = _this.props).changeTheme.apply(_this$props, arguments);

      _this.setState({
        theme: modifyTheme(nextTheme)
      });
    });

    _defineProperty(_assertThisInitialized(_this), "getColor", function (color) {
      var colors = _this.state.theme.colors;
      var colorValue = typeof color === 'number' ? colors.extra[color] : colors[color];
      return colorValue || colors.text;
    });

    return _this;
  }

  _createClass(UiProvider, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      window.addEventListener('touchstart', this.trackTouch);
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this.untrackTouch();
    }
  }, {
    key: "render",
    value: function render() {
      var changeTheme = this.changeTheme;
      var _this$state = this.state,
          touchDetected = _this$state.touchDetected,
          theme = _this$state.theme;
      var _this$props2 = this.props,
          children = _this$props2.children,
          location = _this$props2.location,
          modifyElement = _this$props2.modifyElement;
      return /*#__PURE__*/_react["default"].createElement(_react2.ThemeProvider, {
        theme: theme
      }, /*#__PURE__*/_react["default"].createElement(_Context["default"].Provider, {
        value: {
          getColor: this.getColor,
          location: _isServer["default"] ? location : getLocation(),
          changeTheme: changeTheme,
          touchDetected: touchDetected,
          modifyElement: modifyElement,
          theme: theme
        }
      }, children));
    }
  }]);

  return UiProvider;
}(_react.Component);

exports["default"] = UiProvider;

_defineProperty(UiProvider, "propTypes", {
  changeTheme: _propTypes["default"].func,
  children: _propTypes["default"].node.isRequired,
  location: _propTypes["default"].string,
  modifyElement: _propTypes["default"].func,
  theme: _propTypes["default"].shape()
});

_defineProperty(UiProvider, "defaultProps", {
  changeTheme: function changeTheme() {},
  location: null,
  modifyElement: null,
  theme: {}
});