"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _Context = _interopRequireDefault(require("./Context"));

var _defaultRenderrer = _interopRequireDefault(require("./defaultRenderrer"));

var _invariant = _interopRequireDefault(require("../util/invariant"));

var _excluded = ["children"],
    _excluded2 = ["defaultStyle"],
    _excluded3 = ["modifyElement", "providerIsMissing"];

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var modifyStyles = function modifyStyles(context, _ref, element, ref) {
  var children = _ref.children,
      props = _objectWithoutProperties(_ref, _excluded);

  var _context$theme$elemen = context.theme[element],
      defaultStyle = _context$theme$elemen.defaultStyle,
      styles = _objectWithoutProperties(_context$theme$elemen, _excluded2); // const nextProps = {};
  // const nextStyle = { ...defaultStyle };
  // const keys = Object.keys(props);
  // for (let i = 0; i < keys.length; i += 1) {
  //   const key = keys[i];
  //   const value = props[key];
  //   if (value === true && key in styles) Object.assign(nextStyle, styles[key]);
  //   else if (!(key in styles)) nextProps[key] = value;
  // }


  var _Object$keys$reduce = Object.keys(props).reduce(function (acc, key) {
    var value = props[key];
    if (value === true && key in styles) Object.assign(acc.nextStyle, styles[key]);else if (!(key in styles)) Object.assign(acc.nextProps, _defineProperty({}, key, value));
    return acc;
  }, {
    nextProps: {},
    nextStyle: _objectSpread({}, defaultStyle)
  }),
      nextStyle = _Object$keys$reduce.nextStyle,
      nextProps = _Object$keys$reduce.nextProps;

  var css = _objectSpread(_objectSpread({}, nextStyle), props.css);

  return _objectSpread(_objectSpread(_objectSpread({}, nextProps), context), {}, {
    children: children,
    css: css,
    ref: ref
  });
};

var pickProps = function pickProps(context, props, elementName, ref) {
  if (elementName in context.theme) return modifyStyles(context, props, elementName, ref);
  return _objectSpread(_objectSpread(_objectSpread({}, props), context), {}, {
    ref: ref
  });
};

var withStyle = function withStyle(Element, key) {
  var displayName = Element.displayName;
  var WithStyle = /*#__PURE__*/(0, _react.forwardRef)(function (props, ref) {
    return /*#__PURE__*/_react["default"].createElement(_Context["default"].Consumer, null, function (_ref2) {
      var modifyElement = _ref2.modifyElement,
          providerIsMissing = _ref2.providerIsMissing,
          context = _objectWithoutProperties(_ref2, _excluded3);

      (0, _invariant["default"])(!providerIsMissing, 'Please use the Provider');
      var render = modifyElement || _defaultRenderrer["default"];
      return render(Element, pickProps(context, props, key || displayName, ref));
    });
  });
  WithStyle.contextType = _Context["default"];
  WithStyle.displayName = displayName;
  Element.displayName = "Styled ".concat(displayName); // eslint-disable-line no-param-reassign

  return WithStyle;
};

var _default = withStyle;
exports["default"] = _default;