"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.RawAddon = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _Atom = _interopRequireDefault(require("../Atom"));

var _withStyle = _interopRequireDefault(require("../../Theme/withStyle"));

var _excluded = ["children", "fitAll", "fitLeft", "fitRight"];

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var Addon = function Addon(_ref) {
  var children = _ref.children,
      fitAll = _ref.fitAll,
      fitLeft = _ref.fitLeft,
      fitRight = _ref.fitRight,
      props = _objectWithoutProperties(_ref, _excluded);

  return /*#__PURE__*/_react["default"].createElement(_Atom["default"], _extends({
    element: "span"
  }, props), children);
};

Addon.displayName = 'Addon';
Addon.propTypes = {
  /** React node */
  children: _propTypes["default"].node.isRequired,

  /** Reset Paddings */
  fitAll: _propTypes["default"].bool,

  /** Reset Left Padding */
  fitLeft: _propTypes["default"].bool,

  /** Reset Right Padding */
  fitRight: _propTypes["default"].bool
};
Addon.defaultProps = {
  fitAll: false,
  fitLeft: false,
  fitRight: false
};
var RawAddon = Addon;
exports.RawAddon = RawAddon;

var _default = (0, _withStyle["default"])(Addon);

exports["default"] = _default;