"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = require("@emotion/react");

var _constants = require("./constants");

var _pipe = _interopRequireDefault(require("../../util/pipe"));

var _templateObject, _templateObject2;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _taggedTemplateLiteral(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

var popIn = (0, _react.keyframes)(_templateObject || (_templateObject = _taggedTemplateLiteral(["\n  from {\n    opacity: 0;\n    transform: translateY(48px);\n  }\n  to {\n    opacity: 1;\n    transform: translateY(0px);\n  }\n"])));
var popOut = (0, _react.keyframes)(_templateObject2 || (_templateObject2 = _taggedTemplateLiteral(["\n  to {\n    opacity: 0;\n    transform: translateY(48px);\n  }\n"])));

function getAnimationCss(state) {
  if (state === _constants.DROPDOWN_STATE_ENTERING) {
    return {
      animation: "".concat(popIn, " 0.4s ease forwards")
    };
  }

  if (state === _constants.DROPDOWN_STATE_EXITING) {
    return {
      animation: "".concat(popOut, " 0.24s ease forwards")
    };
  }

  return {};
}

function getStaticCss(animationCss, relative) {
  if (relative) return null;
  return _objectSpread(_objectSpread({}, animationCss), {}, {
    overflow: 'hidden',
    position: 'fixed',
    willChange: 'opacity, transform',
    zIndex: 10
  });
}

var _default = (0, _pipe["default"])(getAnimationCss, getStaticCss);

exports["default"] = _default;