"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _reactDom = require("react-dom");

var _propTypes = _interopRequireDefault(require("prop-types"));

var _reactUse = require("react-use");

var _Paper = _interopRequireDefault(require("../Paper"));

var _getBodyNode = _interopRequireDefault(require("../../util/getBodyNode"));

var _getCss = _interopRequireDefault(require("./getCss"));

var _usePositionBinding = _interopRequireDefault(require("./usePositionBinding"));

var _constants = require("./constants");

var _excluded = ["bindTo", "children", "onExit", "onBeginExit", "onReadyState", "placement", "state"];

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var knownStates = [_constants.DROPDOWN_STATE_DISABLED, _constants.DROPDOWN_STATE_ENTERING, _constants.DROPDOWN_STATE_READY, _constants.DROPDOWN_STATE_EXITING];

var Dropdown = function Dropdown(_ref) {
  var bindTo = _ref.bindTo,
      children = _ref.children,
      onExit = _ref.onExit,
      onBeginExit = _ref.onBeginExit,
      onReadyState = _ref.onReadyState,
      placement = _ref.placement,
      state = _ref.state,
      rest = _objectWithoutProperties(_ref, _excluded);

  var bodyNode = (0, _getBodyNode["default"])();
  var dropdownRef = (0, _react.useRef)(null);
  var dynamicCss = (0, _usePositionBinding["default"])(bindTo, placement);

  function handleAnimationEnd() {
    if (state === _constants.DROPDOWN_STATE_EXITING) onExit();else onReadyState();
  }

  var awayHandler = state === _constants.DROPDOWN_STATE_READY ? onBeginExit : function () {};
  (0, _reactUse.useClickAway)(dropdownRef, awayHandler, ['click']);
  if (state === _constants.DROPDOWN_STATE_DISABLED) return null;

  var output = /*#__PURE__*/_react["default"].createElement(_Paper["default"], _extends({
    rize: 1
  }, rest, {
    atomRef: dropdownRef,
    css: _objectSpread(_objectSpread({}, (0, _getCss["default"])(state)), dynamicCss) // eslint-disable-next-line react/jsx-no-bind
    ,
    onAnimationEnd: handleAnimationEnd
  }), children);

  return /*#__PURE__*/(0, _reactDom.createPortal)(output, bodyNode);
};

Dropdown.displayName = 'Dropdown';
Dropdown.propTypes = {
  bindTo: _propTypes["default"].shape().isRequired,
  children: _propTypes["default"].node.isRequired,
  onBeginExit: _propTypes["default"].func,
  onExit: _propTypes["default"].func,
  onReadyState: _propTypes["default"].func,
  placement: _propTypes["default"].string,
  state: _propTypes["default"].oneOf(knownStates)
};
Dropdown.defaultProps = {
  placement: _constants.DROPDOWN_PALCEMENT_BL,
  state: _constants.DROPDOWN_STATE_DISABLED,
  onBeginExit: undefined,
  onExit: undefined,
  onReadyState: undefined
};
var _default = Dropdown;
exports["default"] = _default;