"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = require("react");

var _reactUseinterval = _interopRequireDefault(require("react-useinterval"));

var _difference = _interopRequireDefault(require("lodash/difference"));

var _values = _interopRequireDefault(require("lodash/values"));

var _constants = require("./constants");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function getDropDownCss(bindTo, placement) {
  if (!bindTo.current) return null;
  var rect = bindTo.current.getBoundingClientRect();
  var top = rect.height + rect.top + 2;

  switch (placement) {
    case _constants.DROPDOWN_PALCEMENT_BL:
      return {
        left: rect.left,
        top: top
      };

    default:
      return {
        right: window.innerWidth - (rect.left + rect.width),
        top: top
      };
  }
}

var _default = function _default(bindTo, placement) {
  var defaultState = getDropDownCss(bindTo, placement);

  var _useState = (0, _react.useState)(defaultState),
      _useState2 = _slicedToArray(_useState, 2),
      state = _useState2[0],
      replaceState = _useState2[1];

  function observeChanges() {
    var nextState = getDropDownCss(bindTo, placement);
    var diff = (0, _difference["default"])((0, _values["default"])(nextState), (0, _values["default"])(state));
    if (diff.length) replaceState(nextState);
  }

  (0, _reactUseinterval["default"])(observeChanges, 32);
  return state;
};

exports["default"] = _default;