"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _Atom = _interopRequireDefault(require("../Atom"));

var _media = _interopRequireDefault(require("../../util/media"));

var _excluded = ["css", "x", "y"];

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var getBoxCss = function getBoxCss(css, x, y) {
  return (0, _media["default"])(_objectSpread(_objectSpread({}, css), {}, {
    overflow: 'hidden',
    overflowY: y ? 'scroll' : undefined,
    overflowX: x ? 'scroll' : undefined,
    overflowScrolling: 'touch',
    position: 'relative',
    scrollBehavior: 'smooth',
    scrollSnapType: 'both mandatory',
    WebkitOverflowScrolling: 'touch'
  }));
};

var ScrollBox = function ScrollBox(_ref) {
  var css = _ref.css,
      x = _ref.x,
      y = _ref.y,
      rest = _objectWithoutProperties(_ref, _excluded);

  return /*#__PURE__*/_react["default"].createElement(_Atom["default"], _extends({}, rest, {
    css: getBoxCss(css, x, y)
  }));
};

ScrollBox.displayName = 'ScrollBox';
ScrollBox.propTypes = {
  children: _propTypes["default"].node.isRequired,
  css: _propTypes["default"].shape(),
  x: _propTypes["default"].bool,
  y: _propTypes["default"].bool
};
ScrollBox.defaultProps = {
  css: null,
  x: false,
  y: false
};
var _default = ScrollBox;
exports["default"] = _default;