"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react2 = require("@emotion/react");

var _Paper = _interopRequireDefault(require("../../atoms/Paper"));

var _templateObject;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _taggedTemplateLiteral(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

var wave = (0, _react2.keyframes)(_templateObject || (_templateObject = _taggedTemplateLiteral(["\n  from {\n    transform: scale(0, 0);\n  }\n  to {\n    transform: scale(1, 1);\n  }\n"])));
var defaultCss = {
  animation: "".concat(wave, " 1.8s cubic-bezier(0.075, 0.820, 0.165, 1.000) forwards 1"),
  display: 'block',
  opacity: 0.24,
  position: 'absolute',
  transition: 'opacity 0.4s ease',
  willChange: 'opacity, transform'
};

var getStyle = function getStyle(released, css) {
  if (released) return _objectSpread(_objectSpread(_objectSpread({}, defaultCss), css), {}, {
    opacity: 0
  });
  return _objectSpread(_objectSpread({}, defaultCss), css);
};

var Wave = function Wave(_ref) {
  var css = _ref.css,
      onDissolve = _ref.onDissolve,
      released = _ref.released,
      size = _ref.size;
  return /*#__PURE__*/_react["default"].createElement(_Paper["default"], {
    element: "span",
    css: getStyle(released, css),
    primary: true,
    size: size,
    onTransitionEnd: onDissolve,
    round: true
  });
};

Wave.propTypes = {
  onDissolve: _propTypes["default"].func,
  released: _propTypes["default"].bool,
  size: _propTypes["default"].number.isRequired,
  css: _propTypes["default"].shape().isRequired
};
Wave.defaultProps = {
  onDissolve: undefined,
  released: false
};
var _default = Wave;
exports["default"] = _default;