"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _Label = _interopRequireDefault(require("./Label"));

var _Body = _interopRequireDefault(require("../../List/Item/Body"));

var _Font = _interopRequireDefault(require("../../../atoms/Font"));

var _withStyle = _interopRequireDefault(require("../../../Theme/withStyle"));

var _excluded = ["color", "css", "hasFocus", "label", "labelIsActive", "outlined", "placeholder", "setLabelWidth", "value"];

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var InputBase = function InputBase(_ref) {
  var color = _ref.color,
      css = _ref.css,
      hasFocus = _ref.hasFocus,
      label = _ref.label,
      labelIsActive = _ref.labelIsActive,
      outlined = _ref.outlined,
      placeholder = _ref.placeholder,
      setLabelWidth = _ref.setLabelWidth,
      value = _ref.value,
      rest = _objectWithoutProperties(_ref, _excluded);

  return /*#__PURE__*/_react["default"].createElement(_Body["default"], {
    fitTop: true,
    fitBottom: true
  }, /*#__PURE__*/_react["default"].createElement(_Font["default"], _extends({}, rest, {
    element: "input",
    css: css,
    placeholder: label || placeholder,
    value: value
  })), label && /*#__PURE__*/_react["default"].createElement(_Label["default"], {
    active: labelIsActive,
    color: color,
    height: css.height,
    label: label,
    outlined: outlined,
    setLabelWidth: setLabelWidth
  }));
};

InputBase.displayName = 'InputBase';
InputBase.propTypes = {
  css: _propTypes["default"].shape(),
  color: _propTypes["default"].string,
  hasFocus: _propTypes["default"].bool.isRequired,
  label: _propTypes["default"].node,
  labelIsActive: _propTypes["default"].bool.isRequired,
  outlined: _propTypes["default"].bool,
  placeholder: _propTypes["default"].node,
  setLabelWidth: _propTypes["default"].func.isRequired,
  value: _propTypes["default"].node.isRequired
};
InputBase.defaultProps = {
  css: {},
  color: null,
  outlined: false,
  placeholder: null,
  label: undefined
};

var _default = (0, _withStyle["default"])(InputBase);

exports["default"] = _default;