"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _List = require("../../List");

var _Outline = _interopRequireDefault(require("../Outline"));

var _excluded = ["children", "hasAddons", "labelIsActive", "labelWidth", "outlined"];

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var InputContainer = function InputContainer(_ref) {
  var children = _ref.children,
      hasAddons = _ref.hasAddons,
      labelIsActive = _ref.labelIsActive,
      labelWidth = _ref.labelWidth,
      outlined = _ref.outlined,
      rest = _objectWithoutProperties(_ref, _excluded);

  var itemElement = hasAddons ? undefined : 'label';

  if (outlined) {
    return /*#__PURE__*/_react["default"].createElement(_Outline["default"], _extends({}, rest, {
      labelIsActive: labelIsActive,
      labelWidth: labelWidth
    }), /*#__PURE__*/_react["default"].createElement(_List.ListItem, {
      css: {
        margin: '-1px'
      },
      element: itemElement,
      transparent: true
    }, children));
  }

  return /*#__PURE__*/_react["default"].createElement(_List.ListItem, _extends({
    element: itemElement
  }, rest), children);
};

InputContainer.propTypes = {
  children: _propTypes["default"].node.isRequired,
  hasAddons: _propTypes["default"].bool.isRequired,
  labelIsActive: _propTypes["default"].bool.isRequired,
  labelWidth: _propTypes["default"].number.isRequired,
  outlined: _propTypes["default"].bool.isRequired
};
var _default = InputContainer;
exports["default"] = _default;