"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _Atom = _interopRequireDefault(require("../../../atoms/Atom"));

var _Paper = _interopRequireDefault(require("../../../atoms/Paper"));

var _withStyle = _interopRequireDefault(require("../../../Theme/withStyle"));

var _excluded = ["children", "css", "labelIsActive", "labelWidth"];

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var InputOutline = function InputOutline(_ref) {
  var children = _ref.children,
      css = _ref.css,
      labelIsActive = _ref.labelIsActive,
      labelWidth = _ref.labelWidth,
      rest = _objectWithoutProperties(_ref, _excluded);

  return /*#__PURE__*/_react["default"].createElement(_Paper["default"], _extends({}, rest, {
    element: "fieldset",
    css: css
  }), /*#__PURE__*/_react["default"].createElement(_Atom["default"], {
    element: "legend",
    css: {
      position: 'relative',
      zIndex: 2,
      marginLeft: '10px',
      paddingTop: 0,
      paddingLeft: 0,
      paddingBottom: 0,
      paddingRight: 0,
      height: '1px',
      // transform: `scaleX(${labelIsActive ? 1 : 0})`,
      transform: 'scaleX(0)',
      transition: 'width 0.16s ease',
      width: "".concat(labelIsActive ? labelWidth + 8 : 0, "px"),
      willChange: 'width'
    }
  }), children);
};

InputOutline.displayName = 'InputOutline';
InputOutline.propTypes = {
  children: _propTypes["default"].node.isRequired,
  css: _propTypes["default"].shape().isRequired,
  labelIsActive: _propTypes["default"].bool.isRequired,
  labelWidth: _propTypes["default"].number.isRequired
};

var _default = (0, _withStyle["default"])(InputOutline);

exports["default"] = _default;