"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.SimpleLinearProgress = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _withStyle = _interopRequireDefault(require("../../Theme/withStyle"));

var _Atom = _interopRequireDefault(require("../../atoms/Atom"));

var _Paper = _interopRequireDefault(require("../../atoms/Paper"));

var _style = require("./style");

var _excluded = ["progress", "height"];

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var getPaperProps = function getPaperProps(height, rest) {
  var nextCss = _objectSpread(_objectSpread({}, rest.css), {}, {
    height: height
  });

  return _objectSpread(_objectSpread({}, rest), {}, {
    css: nextCss
  });
};

var LinearProgress = function LinearProgress(_ref) {
  var progress = _ref.progress,
      height = _ref.height,
      rest = _objectWithoutProperties(_ref, _excluded);

  return /*#__PURE__*/_react["default"].createElement(_Paper["default"], _extends({
    clip: true,
    transparent: true,
    hard: true
  }, getPaperProps(height, rest)), /*#__PURE__*/_react["default"].createElement(_Atom["default"], null), /*#__PURE__*/_react["default"].createElement(_Atom["default"], {
    css: (0, _style.getProgressStyle)(progress)
  }));
};

LinearProgress.displayName = 'LinearProgress';
LinearProgress.propTypes = {
  /** Completed percents */
  progress: _propTypes["default"].number,

  /** Bar height */
  height: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].string])
};
LinearProgress.defaultProps = {
  progress: null,
  height: 8
};
var SimpleLinearProgress = LinearProgress;
exports.SimpleLinearProgress = SimpleLinearProgress;

var _default = (0, _withStyle["default"])(LinearProgress);

exports["default"] = _default;