"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getProgressStyle = exports["default"] = void 0;

var _react = require("@emotion/react");

var _css = _interopRequireDefault(require("../../util/css"));

var _templateObject;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _taggedTemplateLiteral(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

var indeterminate = (0, _react.keyframes)(_templateObject || (_templateObject = _taggedTemplateLiteral(["\n  from {\n    transform: translateX(-100%);\n  }\n  to {\n    transform: translateX(200%);\n  }\n"])));

var getProgressStyle = function getProgressStyle(progress) {
  return progress === null ? {
    animation: "".concat(indeterminate, " 1.6s cubic-bezier(0.6, 0.2, 0.4, 0.8) infinite"),
    width: '50%'
  } : {
    width: "".concat(progress, "%")
  };
};

exports.getProgressStyle = getProgressStyle;

var _default = (0, _css["default"])({
  defaultStyle: {
    position: 'relative',
    '> :first-of-type': {
      height: '100%',
      backgroundColor: 'currentColor',
      opacity: 0.3
    },
    '> :last-of-type': {
      position: 'absolute',
      top: 0,
      left: 0,
      height: '100%',
      backgroundColor: 'currentColor',
      transition: 'width 0.4s ease',
      willChange: 'width'
    }
  }
});

exports["default"] = _default;