"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _Paper = _interopRequireDefault(require("../../../atoms/Paper"));

var _withStyle = _interopRequireDefault(require("../../../Theme/withStyle"));

var _Body = _interopRequireDefault(require("./Body"));

var _excluded = ["BaseElement", "center", "children", "css", "element", "href", "reverse", "small"],
    _excluded2 = ["autoHeight", "blockLevel", "textLeft"];

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var ListItem = /*#__PURE__*/(0, _react.forwardRef)(function (_ref, ref) {
  var BaseElement = _ref.BaseElement,
      center = _ref.center,
      children = _ref.children,
      css = _ref.css,
      element = _ref.element,
      href = _ref.href,
      reverse = _ref.reverse,
      small = _ref.small,
      props = _objectWithoutProperties(_ref, _excluded);

  // eslint-disable-next-line react/prop-types
  var autoHeight = props.autoHeight,
      blockLevel = props.blockLevel,
      textLeft = props.textLeft,
      bodyProps = _objectWithoutProperties(props, _excluded2);

  return /*#__PURE__*/_react["default"].createElement(BaseElement, _extends({
    css: css,
    hard: true,
    href: href,
    element: element,
    atomRef: ref
  }, props), _react.Children.count(children) === 1 ? /*#__PURE__*/_react["default"].createElement(_Body["default"], _extends({
    center: center,
    reverse: reverse,
    small: small
  }, bodyProps), children) : children);
});
ListItem.displayName = 'ListItem';
ListItem.propTypes = {
  BaseElement: _propTypes["default"].oneOfType([_propTypes["default"].elementType, _propTypes["default"].shape({
    render: _propTypes["default"].func.isRequired
  })]),
  center: _propTypes["default"].bool,
  children: _propTypes["default"].node.isRequired,
  css: _propTypes["default"].shape().isRequired,
  href: _propTypes["default"].string,
  element: _propTypes["default"].string,
  reverse: _propTypes["default"].bool,
  small: _propTypes["default"].bool
};
ListItem.defaultProps = {
  BaseElement: _Paper["default"],
  center: false,
  element: undefined,
  href: null,
  reverse: false,
  small: false
};

var _default = (0, _withStyle["default"])(ListItem);

exports["default"] = _default;