"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _Atom = _interopRequireDefault(require("../../atoms/Atom"));

var _withStyle = _interopRequireDefault(require("../../Theme/withStyle"));

var _style = require("./style");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var Spinner = function Spinner(_ref) {
  var borderWidth = _ref.borderWidth,
      children = _ref.children,
      color = _ref.color,
      css = _ref.css,
      getColor = _ref.getColor,
      size = _ref.size;
  return /*#__PURE__*/_react["default"].createElement(_Atom["default"], {
    css: css
  }, /*#__PURE__*/_react["default"].createElement(_Atom["default"], {
    css: (0, _style.getSegmentStyle)(borderWidth, size, getColor(color))
  }), children);
};

Spinner.displayName = 'Spinner';
Spinner.propTypes = {
  borderWidth: _propTypes["default"].string,
  children: _propTypes["default"].node,
  color: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),
  css: _propTypes["default"].shape().isRequired,
  getColor: _propTypes["default"].func.isRequired,
  size: _propTypes["default"].string
};
Spinner.defaultProps = {
  borderWidth: '2.4px',
  children: null,
  color: null,
  size: '24px'
};

var _default = (0, _withStyle["default"])(Spinner);

exports["default"] = _default;