"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getSegmentStyle = exports["default"] = void 0;

var _react = require("@emotion/react");

var _css = _interopRequireDefault(require("../../util/css"));

var _templateObject;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _taggedTemplateLiteral(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

var spin = (0, _react.keyframes)(_templateObject || (_templateObject = _taggedTemplateLiteral(["\n  0% {\n    transform: rotate(0);\n    animation-timing-function: cubic-bezier(0.55, 0.055, 0.675, 0.19);\n  }\n  24% {\n    transform: rotate(900deg);\n    animation-timing-function: cubic-bezier(0.215, 0.61, 0.355, 1);\n  }\n  100% {\n    transform: rotate(1800deg);\n  }\n"])));

var getSegmentStyle = function getSegmentStyle(borderWidth, size, color) {
  return {
    animation: "".concat(spin, " 1.6s cubic-bezier(0.5, 0, 0.5, 1) infinite"),
    borderWidth: borderWidth,
    borderBottomColor: color,
    borderTopColor: color,
    borderLeftColor: 'transparent',
    borderRightColor: 'transparent',
    borderStyle: 'solid',
    borderRadius: '50%',
    boxSizing: 'border-box',
    height: size,
    width: size,
    willChange: 'transform'
  };
};

exports.getSegmentStyle = getSegmentStyle;

var _default = (0, _css["default"])({
  defaultStyle: {
    alignItems: 'center',
    display: 'inline-flex',
    flexDirection: 'column',
    justifyContent: 'center',
    pointerEvents: 'none',
    position: 'relative'
  },
  blockLevel: {
    position: 'absolute',
    top: 0,
    left: 0,
    bottom: 0,
    right: 0
  }
});

exports["default"] = _default;