"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _get = _interopRequireDefault(require("lodash/get"));

var _Paper = _interopRequireDefault(require("../../atoms/Paper"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var TabsIndicator = function TabsIndicator(_ref) {
  var activeTab = _ref.activeTab,
      color = _ref.color,
      height = _ref.height,
      domNode = _ref.domNode;
  var tabNode = (0, _get["default"])(domNode, ['childNodes', activeTab]);
  if (!tabNode) return null;
  var offsetLeft = tabNode.offsetLeft,
      offsetWidth = tabNode.offsetWidth;
  var css = {
    backgroundColor: color,
    bottom: 0,
    height: "".concat(height, "px"),
    left: 0,
    position: 'absolute',
    transform: "translateX(".concat(offsetLeft, "px)"),
    transition: 'transform 0.24s ease, width 0.24s ease',
    width: "".concat(offsetWidth, "px"),
    willChange: 'transform, width'
  };
  return /*#__PURE__*/_react["default"].createElement(_Paper["default"], {
    css: css
  });
};

TabsIndicator.propTypes = {
  activeTab: _propTypes["default"].number.isRequired,
  color: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),
  height: _propTypes["default"].number.isRequired,
  domNode: _propTypes["default"].object // eslint-disable-line react/forbid-prop-types

};
TabsIndicator.defaultProps = {
  color: undefined,
  domNode: null
};
var _default = TabsIndicator;
exports["default"] = _default;