"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.SimpleTabs = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _get2 = _interopRequireDefault(require("lodash/get"));

var _Paper = _interopRequireDefault(require("../../atoms/Paper"));

var _withStyle = _interopRequireDefault(require("../../Theme/withStyle"));

var _Indicator = _interopRequireDefault(require("./Indicator"));

var _excluded = ["activeTab", "center", "children", "color", "indicatorHeight", "getColor", "noIndicator", "onChange", "reverse", "right"];

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var Tabs = /*#__PURE__*/function (_Component) {
  _inherits(Tabs, _Component);

  var _super = _createSuper(Tabs);

  function Tabs() {
    var _this;

    _classCallCheck(this, Tabs);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));

    _defineProperty(_assertThisInitialized(_this), "state", {
      activeTab: 0,
      domNode: null
    });

    _defineProperty(_assertThisInitialized(_this), "ref", function (domNode) {
      return _this.setState({
        domNode: domNode
      });
    });

    return _this;
  }

  _createClass(Tabs, [{
    key: "activeTab",
    get: function get() {
      return (0, _get2["default"])(this.props, 'activeTab', this.state.activeTab);
    }
  }, {
    key: "children",
    get: function get() {
      var _this2 = this;

      var _this$props = this.props,
          children = _this$props.children,
          color = _this$props.color,
          noIndicator = _this$props.noIndicator;
      var activeTab = this.activeTab;

      var childrenArray = _react.Children.toArray(children);

      return childrenArray.map(function (child, index) {
        var isActive = index === activeTab;
        var nextProps = {
          hardLeft: noIndicator && index > 0 ? true : undefined,
          hardRight: noIndicator && index < childrenArray.length - 1 ? true : undefined,
          hardBottom: noIndicator ? undefined : true,
          onClick: function onClick(event) {
            _this2.setState({
              activeTab: index
            });

            _this2.props.onChange(index);

            var onClick = child.props.onClick;
            if (typeof onClick === 'function') onClick(event);
          }
        };

        if (isActive) {
          Object.assign(nextProps, {
            color: child.props.color || color
          });
        }

        return /*#__PURE__*/(0, _react.cloneElement)(child, nextProps);
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props2 = this.props,
          activeTab = _this$props2.activeTab,
          center = _this$props2.center,
          children = _this$props2.children,
          color = _this$props2.color,
          indicatorHeight = _this$props2.indicatorHeight,
          getColor = _this$props2.getColor,
          noIndicator = _this$props2.noIndicator,
          onChange = _this$props2.onChange,
          reverse = _this$props2.reverse,
          right = _this$props2.right,
          rest = _objectWithoutProperties(_this$props2, _excluded);

      var domNode = this.state.domNode;
      return /*#__PURE__*/_react["default"].createElement(_Paper["default"], _extends({}, rest, {
        atomRef: this.ref
      }), this.children, !noIndicator && /*#__PURE__*/_react["default"].createElement(_Indicator["default"], {
        activeTab: this.activeTab,
        color: getColor(color),
        height: indicatorHeight,
        domNode: domNode
      }));
    }
  }]);

  return Tabs;
}(_react.Component);

Tabs.propTypes = {
  // # of the active tab
  activeTab: _propTypes["default"].number,
  // eslint-disable-line react/require-default-props
  // Align tabs to center
  center: _propTypes["default"].bool,
  // Tabs
  children: _propTypes["default"].node.isRequired,
  // Active tab color
  color: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),
  // Privider utility
  getColor: _propTypes["default"].func.isRequired,
  // Indicator height
  indicatorHeight: _propTypes["default"].number,
  // Do not render indicator
  noIndicator: _propTypes["default"].bool,
  // Tab click handler
  onChange: _propTypes["default"].func,
  // Reverse tabs
  reverse: _propTypes["default"].bool,
  // Align tabs to end
  right: _propTypes["default"].bool
};
Tabs.defaultProps = {
  center: false,
  color: 'text',
  indicatorHeight: 2,
  noIndicator: false,
  onChange: function onChange() {},
  reverse: false,
  right: false
};
Tabs.displayName = 'Tabs';
var SimpleTabs = Tabs;
exports.SimpleTabs = SimpleTabs;

var _default = (0, _withStyle["default"])(Tabs);

exports["default"] = _default;