"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _upperFirst = _interopRequireDefault(require("lodash/upperFirst"));

var _breakpoints = _interopRequireDefault(require("./breakpoints"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function createMediaQuery(min, max, key) {
  if (min === null && max === null || min === 0 && max === null) return null;
  var query = min ? "all and (min-width: ".concat(min, "px)") : 'all';
  if (max !== null) query = "".concat(query, " and (max-width: ").concat(max, "px)");
  return _defineProperty({}, key, query);
}

var _default = function _default() {
  var breakpoints = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : _breakpoints["default"];
  return breakpoints.reduce(function (acc, breakpoint, index) {
    var key = Object.keys(breakpoint).shift();
    var nextBreakPoint = breakpoints[index + 1];
    var upperKey = (0, _upperFirst["default"])(key);
    var min = breakpoint[key];
    var max = nextBreakPoint ? Object.values(nextBreakPoint).shift() - 1 : null;
    return _objectSpread(_objectSpread(_objectSpread(_objectSpread({}, acc), createMediaQuery(min, max, key)), createMediaQuery(null, max, "atLeast".concat(upperKey))), createMediaQuery(min, null, "atMost".concat(upperKey)));
  }, {});
};

exports["default"] = _default;